//+------------------------------------------------------------------+
//|                                                    MA_Greeen.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Lime
#property  indicator_color2  Red
#property  indicator_color3  DarkSlateGray
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  2
#property indicator_level1 0
#property indicator_levelcolor SteelBlue
extern int m1=20;
extern int m2=10;
extern int SignalSMA=5;
extern int    mBar  = 500;


double Buf_0[],Buf_1[],Buf_2[],Buf_3[],Buf_4[];
double     Up[];
double     Down[];
double     SignalBuffer[];
int init()  { 
   IndicatorBuffers(8); 
   SetIndexStyle(0,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(0,159);
   SetIndexBuffer(0,Up);
   SetIndexStyle(1,DRAW_ARROW,EMPTY,1);
   SetIndexArrow(1,159);
   SetIndexBuffer(1,Down);   
   SetIndexStyle(2,DRAW_LINE,EMPTY,2);
   SetIndexDrawBegin(2,SignalSMA);
   SetIndexBuffer(2,SignalBuffer);
      
   SetIndexBuffer(7,Buf_0);
   ArraySetAsSeries(Buf_4,true);
   ArraySetAsSeries(Buf_3,true);
   ArraySetAsSeries(Buf_2,true);
   ArraySetAsSeries(Buf_1,true);
SetIndexBuffer(3,Buf_1);
SetIndexBuffer(4,Buf_2);  
SetIndexBuffer(5,Buf_3);
SetIndexBuffer(6,Buf_4);  
IndicatorShortName("MA_Greeen("+m1+","+m2+","+SignalSMA+")");
   return; 
}

int deinit()  {return(0);}

int start()  {   
   int i,Counted_bars;
   ArrayResize(Buf_4,ArraySize(Buf_0)); 
   ArrayResize(Buf_3,ArraySize(Buf_0)); 
   ArrayResize(Buf_2,ArraySize(Buf_0)); 
   ArrayResize(Buf_1,ArraySize(Buf_0)); 
    
for(i=mBar;i>=0;i--)  
    {
     Buf_1[i]=iMA(NULL,0,m1,0,MODE_LWMA,PRICE_CLOSE,i);
     Buf_2[i]=iMA(NULL,0,m1,0,MODE_LWMA,PRICE_OPEN,i);
    }
for(i=mBar;i>=0;i--)  
    {
     Buf_3[i]=iMAOnArray(Buf_1,0,m2,0,MODE_LWMA,i);
     Buf_4[i]=iMAOnArray(Buf_2,0,m2,0,MODE_LWMA,i);
    }
for(i=mBar;i>=0;i--)  
    {
     Buf_0[i]=(Buf_3[i]-Buf_4[i])*1000;
    }
for(i=mBar;i>=0;i--)
     {
       Up[i]=Buf_0[i];     // Uptrend bbMacd
       Down[i]=Buf_0[i];     // downtrend bbMacd
       if(Buf_0[i] > Buf_0[i+1]) Down[i] = EMPTY_VALUE;
       if(Buf_0[i] < Buf_0[i+1]) Up[i] = EMPTY_VALUE;
     SignalBuffer[i]=iMAOnArray(Buf_0,Bars,SignalSMA,0,MODE_SMA,i);  
     }     
    
   return;
}